#include "DoraBaseDocument.h"

DoraRuntimeClass DoraBaseDocument::classDoraBaseDocument = {"DoraBaseDocument", NULL, DoraBaseDocument::CreateDocument};

DoraClassObject *DoraBaseDocument::CreateObject(QWidget *parent = 0)
{
  return NULL;
}

DoraClassObject *DoraBaseDocument::CreateDocument()
{
  return new DoraBaseDocument();
}

void DoraBaseDocument::OnInitDocument()
{
}

void DoraBaseDocument::saveRecord()
{
}

void DoraBaseDocument::loadRecord()
{
}

void DoraBaseDocument::setRegistry(DoraClassObject *pObject, DoraBaseView *pView, CString class_name)
{
  RegistryStruct regStr;
  regStr.viewObject  = pObject;
  regStr.viewClass   = pView;
  regStr.class_name  = class_name.p;
  regStr.isVisible = 0;
  regStr.isActive = 0;
  int maxElement = localRegistry.maxElement() + 1;
  setElementRegistry(regStr, maxElement);
}

/*
void DoraBaseDocument::setRegistry(DoraClassObject *pObject, DoraBaseDialog *pDialog, CString class_name)
{
  RegistryStruct regStr;
  regStr.viewObject  = pObject;
  regStr.viewClass   = NULL;
  regStr.dialogClass = pDialog;
  regStr.class_name  = class_name;
  regStr.isVisible = 0;
  regStr.isActive  = 0;
  int maxElement = localRegistry.maxElement() + 1;
  setElementRegistry(regStr, maxElement);
}
*/

void DoraBaseDocument::setElementRegistry(RegistryStruct regStruct, const int index)
{
  RegistryStruct regStr;
  regStr.viewObject  = regStruct.viewObject;
  regStr.viewClass   = regStruct.viewClass;
  regStr.class_name  = regStruct.class_name;
  regStr.isVisible   = regStruct.isVisible;
  regStr.isActive    = regStruct.isActive;
  localRegistry.setElement(regStr, index);
}

void DoraBaseDocument::searchObject(CString class_name)
{
  int maxElement = localRegistry.maxElement();
  for(int i = 0; i <= maxElement - 1; i++) {
    Str35 s;
    s = "";s = class_name.p;
    if(localRegistry[i].class_name == s) {
      if(localRegistry[i].viewClass != NULL)
	localRegistry[i].viewClass->OnUpdateView();
      break;
    }
  }
}

void DoraBaseDocument::setActiveObject(CString class_name)
{
  int maxElement = localRegistry.maxElement();
  for(int i = 0; i <= maxElement - 1; i++) {
    Str35 s;
    s = "";s = class_name.p;
    if(localRegistry[i].class_name == s) {
      RegistryStruct regStr;
      regStr.viewObject  = localRegistry[i].viewObject;
      regStr.viewClass   = localRegistry[i].viewClass;
      regStr.class_name  = localRegistry[i].class_name;
      regStr.isActive = 1;
      regStr.isVisible = localRegistry[i].isVisible;
      setElementRegistry(regStr, i + 1);
      if(localRegistry[i].viewClass != NULL) {
	localRegistry[i].viewClass->show();
	localRegistry[i].viewClass->setFocus();
      }
    }
  }
}

void DoraBaseDocument::setVisibleObject(CString class_name)
{
  int maxElement = localRegistry.maxElement();
  for(int i = 0; i <= maxElement - 1; i++) {
    Str35 s;
    s = "";s = class_name.p;
    if(localRegistry[i].class_name == s) {
      RegistryStruct regStr;
      regStr.viewObject  = localRegistry[i].viewObject;
      regStr.viewClass   = localRegistry[i].viewClass;
      regStr.class_name  = localRegistry[i].class_name;
      regStr.isActive  = localRegistry[i].isActive;
      regStr.isVisible = 1;
      setElementRegistry(regStr, i + 1);
      if(localRegistry[i].viewClass != NULL) {
	localRegistry[i].viewClass->show();
	localRegistry[i].viewClass->setFocus();
      }
    }
  }
}

int DoraBaseDocument::isActiveObject(CString class_name)
{
  int active = 0;
  int  maxElement = localRegistry.maxElement();
  for(int i = 0; i <= maxElement - 1; i++) {
    Str35 s;
    s = "";s = class_name.p;
    if(localRegistry[i].class_name == s)
      active = localRegistry[i].isActive;
  }
  return active;
}

int DoraBaseDocument::isVisibleObject(CString class_name)
{
  int visible = 0;
  int  maxElement = localRegistry.maxElement();
  for(int i = 0; i <= maxElement - 1; i++) {
    Str35 s;
    s = "";s = class_name.p;
    if(localRegistry[i].class_name == s)
      visible = localRegistry[i].isVisible;
  }
  return visible;
}

void DoraBaseDocument::setNotActiveObject(CString class_name)
{
  int maxElement = localRegistry.maxElement();
  for(int i = 0; i <= maxElement - 1; i++) {
    Str35 s;
    s = "";s = class_name.p;
    if(localRegistry[i].class_name == s) {
      RegistryStruct regStr;
      regStr.viewObject  = localRegistry[i].viewObject;
      regStr.viewClass   = localRegistry[i].viewClass;
      regStr.class_name  = localRegistry[i].class_name;
      regStr.isVisible  = localRegistry[i].isVisible;
      regStr.isActive = 0;
      setElementRegistry(regStr, i + 1);
      if(localRegistry[i].viewClass != NULL)
	localRegistry[i].viewClass->hide();
    }
  }
}

void DoraBaseDocument::setNotVisibleObject(CString class_name)
{
  int maxElement = localRegistry.maxElement();
  for(int i = 0; i <= maxElement - 1; i++) {
    Str35 s;
    s = "";s = class_name.p;
    if(localRegistry[i].class_name == s) {
      RegistryStruct regStr;
      regStr.viewObject  = localRegistry[i].viewObject;
      regStr.viewClass   = localRegistry[i].viewClass;
      regStr.class_name  = localRegistry[i].class_name;
      regStr.isActive  = localRegistry[i].isActive;
      regStr.isVisible = 0;
      setElementRegistry(regStr, i + 1);
      if(localRegistry[i].viewClass != NULL)
	localRegistry[i].viewClass->hide();
    }
  }
}

int DoraBaseDocument::getIndexObject(CString class_name)
{
  int index = -1;
  int maxElement = localRegistry.maxElement();
  for(int i = 0; i <= maxElement - 1; i++) {
    Str35 s;
    s = "";s = class_name.p;
    if(localRegistry[i].class_name == s) {
      index = i;
      break;
    }
  }
  return index;
}

int DoraBaseDocument::getMaxElementRegistry()
{
  int maxElement = localRegistry.maxElement();
  return maxElement;
}

CString DoraBaseDocument::getClassNameRegistry(int index)
{
  CString class_name;
  class_name = "";
  class_name = localRegistry[index].class_name;
  return class_name;
}

DoraBaseView *DoraBaseDocument::getTopView()
{
  DoraBaseView *m_pView;
  int maxElement = localRegistry.maxElement();
  m_pView = NULL;
  for(int i = 0; i <= maxElement - 1; i++) {
    if(localRegistry[i].viewClass != NULL)
      m_pView = localRegistry[i].viewClass;
  }
  
  return m_pView;
}










