#if !defined(_DORABASEDOCUMENT_H)
#define _DORABASEDOCUMENT_H

#include <qwidget.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraTempStruct.h"

class DoraBaseDocument : public DoraClassObject
{
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraBaseDocument;
  }
  static DoraRuntimeClass classDoraBaseDocument;
  static DoraClassObject *CreateObject(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraBaseDocument() : DoraClassObject() {
    printf("   DoraBaseDocument\n");
    localRegistry.removeAllElement();
  }
  ~DoraBaseDocument() {
    printf("   DoraBaseDocument\n");
  }

public:
  virtual void OnInitDocument();
  virtual void saveRecord();
  virtual void loadRecord();

public:
  void setRegistry(DoraClassObject *pObject, DoraBaseView *pView, CString class_name);
  void setElementRegistry(RegistryStruct regStruct, const int index);
  void searchObject(CString class_name);
  void setActiveObject(CString class_name);
  void setVisibleObject(CString class_name);
  int  isActiveObject(CString class_name);
  int  isVisibleObject(CString class_name);
  void setNotActiveObject(CString class_name);
  void setNotVisibleObject(CString class_name);
  int  getIndexObject(CString class_name);
  int  getMaxElementRegistry();
  CString getClassNameRegistry(int index);
  DoraBaseView   *getTopView();

private:
   TypeRegistryItem localRegistry;

};

#endif


